
#ifndef JunaSound_StreamRecorder_H
#define JunaSound_StreamRecorder_H


#include "OutputStream.h"

namespace Juna {
namespace Sound {

class I_RecordDriver;

//R[_C^[tFCX
class I_StreamRecorder
{
protected:
	~I_StreamRecorder() {}
public:
//^Jn܂B
	virtual bool Start(void) = 0;
//^~܂B
	virtual bool Stop(void) = 0;
//^ǂB
	virtual bool isRecording(void) const = 0;

/*
	^f[^󂯎o̓Xg[ݒ肵܂
	Ƃ̃Xg[AddRef()ĂяoA
	܂Őݒ肳ĂXg[Release()ĂяoB
	0ݒ肷ƏԂɖ߂B
*/
	virtual bool SetReceiver(I_OutputStream *setStream) = 0;

//ݒ肳ꂽtH[}bg擾܂B
	virtual Format GetFormat(void) const = 0;
//Ɏۂɐݒ肳ꂽobt@TCY擾܂B
	virtual void GetBufferSize(long &oBufsize,int &oBufnum) const = 0;

//hCõC^[tFCX̃|C^(ID)擾܂B
	virtual const I_RecordDriver *GetDriver(void) const = 0;
};

//foCX\
struct RecordDeviceData {char *name;};
struct RecordDeviceDataW {unsigned short *name;};


//R[hhCoC^[tFCX
class I_RecordDriver
{
protected:
	~I_RecordDriver() {}
public:
//R[_CX^X𐶐
	virtual I_StreamRecorder *CreateRecorder
		(int iDevice,							//foCXCfbNX
		 const Format &iFormat,					//tH[}bg
		 long iBufsize = 0,int iBufnum = 4) = 0;//obt@̃TCY
//R[_CX^X폜
	virtual bool DestroyRecorder(I_StreamRecorder *recorder) = 0;

//̃hCoŃR[_IׂfoCX̐
	virtual int GetDeviceNum(void) = 0;
//foCX̎擾
	virtual const RecordDeviceData *GetDeviceData(int index) = 0;
	virtual const RecordDeviceDataW *GetDeviceDataW(int index) = 0;
//w̃tH[}bgŃfoCXJ邩
	virtual bool TestOpenDevice(int index,const Format &format) = 0;

//foCX񃊃XgCӂɍXV
	virtual void UpdateDeviceList(void) = 0;
	virtual void UpdateDeviceListW(void) = 0;
//foCX񃊃XgɎgĂ郁
	virtual void DeleteDeviceList(void) = 0;
};

//R[hhCo̐
int GetRecordDriverNum(void);
//R[hhCo̖O
const char *GetRecordDriverName(int index);
const unsigned short *GetRecordDriverNameW(int index);
//R[hhCõC^[tFCX擾
I_RecordDriver *GetRecordDriverInterface(int index);


}//namespace Sound
}//namespace Juna

#endif
