
#ifndef JunaSound_DirectSoundCaptureStreamRecordDriver_H
#define JunaSound_DirectSoundCaptureStreamRecordDriver_H

#include "WindowsRecorder.h"

#ifndef DIRECTSOUND_VERSION
//8ȏŖ΂Ȃł悳AƂȂ5
#define DIRECTSOUND_VERSION 0x0500
#endif
#include <dsound.h>

namespace Juna {
namespace Sound {


class DSCaptureRecordDriver : public I_DSCaptureRecordDriver
{
	DSCaptureRecordDriver(void);
public:
	~DSCaptureRecordDriver();

	virtual I_StreamRecorder *CreateRecorder
		(int iDevice,const Format &iFormat,long iBufsize = 0,int iBufnum = 4);
	virtual bool DestroyRecorder(I_StreamRecorder *player);

	virtual int GetDeviceNum(void);
	virtual const RecordDeviceData *GetDeviceData(int index)
	{return GetDSCDeviceData(index);}
	virtual const RecordDeviceDataW *GetDeviceDataW(int index)
	{return GetDSCDeviceDataW(index);}
	virtual bool TestOpenDevice(int index,const Format &format);

	virtual void UpdateDeviceList(void);
	virtual void UpdateDeviceListW(void);
	virtual void DeleteDeviceList(void);


	virtual const DSCaptDeviceData *GetDSCDeviceData(int index);
	virtual const DSCaptDeviceDataW *GetDSCDeviceDataW(int index);
	virtual const GUID *GetDSCDeviceGUID(int index);

	static DSCaptureRecordDriver *GetInstance(void);



//private + friend ɂ邩Y񂾂ǁAŁB
	typedef HRESULT (WINAPI *typeDSCCreate)(LPCGUID ,LPDIRECTSOUNDCAPTURE *,LPUNKNOWN);
	const typeDSCCreate GetDSCCreateProc(void);

private:
	HINSTANCE LoadDll(void);
	void FreeDll(void);

	void InitDeviceNum(void);

	typedef HRESULT (WINAPI *typeDSCEnumA)(LPDSENUMCALLBACKA,LPVOID);
	typedef HRESULT (WINAPI *typeDSCEnumW)(LPDSENUMCALLBACKW,LPVOID);
	const typeDSCEnumA GetEnumProcA(void);
	const typeDSCEnumW GetEnumProcW(void);

	DSCaptDeviceData *list;
	DSCaptDeviceDataW *wlist;
	int IndexNum;
	HINSTANCE hDSdll;

private:
	DSCaptureRecordDriver(DSCaptureRecordDriver &);
	void operator=(const DSCaptureRecordDriver &);
};

}//namespace Sound
}//namespace Juna

#endif

