
#ifndef JunaSound_DirectSoundCaptureStreamRecorder_H
#define JunaSound_DirectSoundCaptureStreamRecorder_H

#include "../Recorder.h"

#include <windows.h>
struct IDirectSoundCapture;
struct IDirectSoundCaptureBuffer;


namespace Juna {
namespace Sound {

class DirectSoundCaptureRecorder : private I_StreamRecorder
{
	friend class DSCaptureRecordDriver;
public:
	DirectSoundCaptureRecorder(void);

	~DirectSoundCaptureRecorder() {Finalize();}

	I_StreamRecorder *Initialize
		(int iDevice,const Format &iFormat,long iBufsize = 0,int iBufnum = 4);
	void Finalize(void);

	I_StreamRecorder *GetRecorder(void)
	{return lpDSCBuffer != 0 ? this : 0;}
	const I_StreamRecorder *GetRecorder(void) const
	{return lpDSCBuffer != 0 ? this : 0;}

private:
	virtual bool Start(void);
	virtual bool Stop(void);
	virtual bool isRecording(void) const;

	virtual bool SetReceiver(I_OutputStream *setOutputStream);

	virtual Format GetFormat(void) const {return RecordFormat;}

	virtual void GetBufferSize(long &oBufsize,int &oBufnum) const
	{
		oBufsize = BufferSize;
		oBufnum = BufferNum;
	}
	virtual const I_RecordDriver *GetDriver(void) const;

private:
	IDirectSoundCapture *lpDirectSoundCaptureObject;	//

	IDirectSoundCaptureBuffer *lpDSCBuffer;	//^foCX

	Format RecordFormat;

	long BufferSize;	//obt@TCY
	int BufferNum;		//obt@̐
	volatile int ReadBufferPos;	//ɏobt@̈ʒu

	I_OutputStream *Receiver;	//f[^o͂Xg[

	HANDLE hNotifyEvent[2];	//^o߁A~ʒmCxg
	HANDLE hThread;			//obt@Xbh̃nh
	CRITICAL_SECTION CritSect;
	enum THREAD_STATE{TS_EXIT = 0,TS_STANDBY = 1,TS_RECORD = 2,TS_RECORDEND = 3};
	volatile THREAD_STATE ThreadState;


	static unsigned __stdcall RecordThread(void *DSCRecorder);

private://
	DirectSoundCaptureRecorder(DirectSoundCaptureRecorder &);
	void operator=(const DirectSoundCaptureRecorder &);
};

}//namespace Sound
}//namespace Juna

#endif

