
#include <windows.h>
#include <mmreg.h>
#include <ks.h>
#include <ksmedia.h>

#include "../../Format.h"

namespace Juna {
namespace Sound {

int GetWaveFormatExtensibleSize(void) {return sizeof(WAVEFORMATEXTENSIBLE);}

bool MakeExtensibleFormat(WAVEFORMATEX *wfx)
{
	if (wfx->cbSize < sizeof(WAVEFORMATEXTENSIBLE) - sizeof(WAVEFORMATEX))
		return false;
	WAVEFORMATEXTENSIBLE *wfxe = (WAVEFORMATEXTENSIBLE *)wfx;

	WORD ft = wfx->wFormatTag;
	switch (ft)
	{
	case WAVE_FORMAT_PCM:
		memcpy(&wfxe->SubFormat,&KSDATAFORMAT_SUBTYPE_PCM,sizeof(GUID));
		break;
	case WAVE_FORMAT_IEEE_FLOAT:
		memcpy(&wfxe->SubFormat,&KSDATAFORMAT_SUBTYPE_IEEE_FLOAT,sizeof(GUID));
		break;
	default:
		return false;
	}
	wfxe->Format.wFormatTag = WAVE_FORMAT_EXTENSIBLE;
	wfxe->Samples.wValidBitsPerSample = wfxe->Format.wBitsPerSample;

	switch(wfxe->Format.nChannels)
	{
	case 1:wfxe->dwChannelMask = KSAUDIO_SPEAKER_MONO;break;
	case 2:wfxe->dwChannelMask = KSAUDIO_SPEAKER_STEREO;break;
	case 4:wfxe->dwChannelMask = KSAUDIO_SPEAKER_QUAD;break;
	case 6:wfxe->dwChannelMask = KSAUDIO_SPEAKER_5POINT1;break;
	case 8:wfxe->dwChannelMask = KSAUDIO_SPEAKER_7POINT1;break;
	}
	return true;
}

void SetWaveFormatEx(WAVEFORMATEX &wfex,const Format &format)
{
//	wfex.wFormatTag			= WAVE_FORMAT_PCM;
	wfex.nChannels			= format.channel;
	wfex.nSamplesPerSec		= format.frequency;
	wfex.nAvgBytesPerSec	= format.frequency * format.sample_size();
	wfex.nBlockAlign		= format.sample_size();
	wfex.wBitsPerSample		= format.bit;
	wfex.cbSize = 0;

	switch (format.quantization)
	{
	case QT_UNSIGNED:
	case QT_SIGNED:
		wfex.wFormatTag = WAVE_FORMAT_PCM;
		break;
	case QT_FLOAT:
		wfex.wFormatTag = WAVE_FORMAT_IEEE_FLOAT;
		break;
	default:
		wfex.wFormatTag = 0;
	}
}


}//namespace Sound
}//namespace Juna