
#ifndef JunaSound_WindowsStreamRecorder_H
#define JunaSound_WindowsStreamRecorder_H

#include "../Recorder.h"

#include <windows.h>

namespace Juna {
namespace Sound {
#pragma pack(push, 8)

struct waveInDeviceData : public RecordDeviceData {
	UINT ID;
	WAVEINCAPSA wicaps;
};
struct waveInDeviceDataW : public RecordDeviceDataW {
	UINT ID;
	WAVEINCAPSW wicaps;
};

class I_waveInRecordDriver : public I_RecordDriver
{
protected:
	~I_waveInRecordDriver() {};
public:

	virtual const waveInDeviceData *GetWIDeviceData(int index) = 0;
	virtual const waveInDeviceDataW *GetWIDeviceDataW(int index) = 0;

	virtual const UINT *GetWIDeviceID(int index) = 0;
};

struct DSCaptDeviceData : public RecordDeviceData {
	GUID guid;
	char *Module;
};
struct DSCaptDeviceDataW : public RecordDeviceDataW {
	GUID guid;
	unsigned short *Module;
};

class I_DSCaptureRecordDriver : public I_RecordDriver
{
protected:
	~I_DSCaptureRecordDriver() {};
public:

	virtual const DSCaptDeviceData *GetDSCDeviceData(int index) = 0;
	virtual const DSCaptDeviceDataW *GetDSCDeviceDataW(int index) = 0;

	virtual const GUID *GetDSCDeviceGUID(int index) = 0;
};

I_waveInRecordDriver *GetWaveInRecordDriver(void);
I_DSCaptureRecordDriver *GetDSCaptureRecordDriver(void);


#pragma pack(pop)
}//namespace Sound
}//namespace Juna

#endif
