
#ifndef JunaSound_waveInStreamRecordDriver_H
#define JunaSound_waveInStreamRecordDriver_H

#include "WindowsRecorder.h"

namespace Juna {
namespace Sound {


class waveInRecordDriver : public I_waveInRecordDriver
{
	waveInRecordDriver(void);
public:
	~waveInRecordDriver();

	virtual I_StreamRecorder *CreateRecorder
		(int iDevice,const Format &iFormat,long iBufsize,int iBufnum);
	virtual bool DestroyRecorder(I_StreamRecorder *recorder);

	virtual int GetDeviceNum(void);
	virtual const RecordDeviceData *GetDeviceData(int index);
	virtual const RecordDeviceDataW *GetDeviceDataW(int index);
	virtual bool TestOpenDevice(int index,const Format &format);

	virtual void MakeDeviceList(void);
	virtual void MakeDeviceListW(void);
	virtual void DeleteDeviceList(void);


	virtual const waveInDeviceData *GetWIDeviceData(int index);
	virtual const waveInDeviceDataW *GetWIDeviceDataW(int index);
	virtual const UINT *GetWIDeviceID(int index);

	static waveInRecordDriver *GetInstance(void);
private:
	waveInDeviceData *list;
	waveInDeviceDataW *wlist;

private:
	waveInRecordDriver(waveInRecordDriver &);
	void operator=(const waveInRecordDriver &);
};


}//namespace Sound
}//namespace Juna

#endif

