
#ifndef JunaSound_waveInStreamRecorder_H
#define JunaSound_waveInStreamRecorder_H

#include "../Recorder.h"

#include <windows.h>
#include <mmsystem.h>


namespace Juna {
namespace Sound {

class waveInRecorder : public I_StreamRecorder
{
	friend class waveInRecordDriver;
public:
	waveInRecorder(void);
	~waveInRecorder() {Finalize();}

	I_StreamRecorder *Initialize
		(int iDevice,const Format &iFormat,long iBufsize = 0,int iBufnum = 4);
	void Finalize(void);

	I_StreamRecorder *GetRecorder(void)
	{return hWaveIn != 0 ? this : 0;}
	const I_StreamRecorder *GetRecorder(void) const
	{return hWaveIn != 0 ? this : 0;}

private:
	virtual bool Start(void);
	virtual bool Stop(void);
	virtual bool isRecording(void) const;

	virtual bool SetReceiver(I_OutputStream *setReceiver);

	virtual Format GetFormat(void) const {return RecordFormat;}

	virtual void GetBufferSize(long &oBufsize,int &oBufnum) const
	{
		oBufsize = BufferSize;
		oBufnum = BufferNum;
	}

	virtual const I_RecordDriver *GetDriver(void) const;

private:
	HWAVEIN hWaveIn;	//^foCX

	Format RecordFormat;

	WAVEHDR *WaveHdr;	//obt@
	long BufferSize;	//obt@TCY
	int BufferNum;		//obt@̐
	volatile int ReadBufferPos;	//ɏobt@̈ʒu

	HANDLE hCallbackEvent;	//^o߁A~ʒmCxg
	HANDLE hThread;			//obt@Xbh̃nh
	CRITICAL_SECTION CritSect;
	enum THREAD_STATUS {TS_EXIT = 0,TS_STANDBY = 1,TS_RECORD = 2,TS_RECORDEND = 3};
	volatile THREAD_STATUS ThreadState;	//Xbh̏

	I_OutputStream *Receiver;	//f[^n[q

	static unsigned __stdcall RecordThread(void *wiRecorder);

	bool SetupDevice(int device,const Format &format,
					 long bufsize,int bufnum);

private:
	waveInRecorder(waveInRecorder &);
	void operator=(const waveInRecorder &);
};

}//namespace Sound
}//namespace Juna

#endif

