
#ifndef JunaSound_waveOutStreamPlayDriver_H
#define JunaSound_waveOutStreamPlayDriver_H

#include "WindowsPlayer.h"
#include <windows.h>
#include <mmsystem.h>


namespace Juna {
namespace Sound {


class waveOutPlayDriver : public I_waveOutPlayDriver
{
protected:
	waveOutPlayDriver(void);
public:
	~waveOutPlayDriver();

	virtual I_StreamPlayer *CreateStreamPlayer
		(int iDevice,const Format &iFormat,long iBufsize = 0,int iBufnum = 3)
	{return CreateWOStreamPlayer(iDevice,iFormat,iBufsize,iBufnum);}

	virtual I_StreamPlayer *CreateStreamPlayer
		(int iDevice,I_InputStream &setStream,long iBufsize = 0,int iBufnum = 3)
	{return CreateWOStreamPlayer(iDevice,setStream,iBufsize,iBufnum);}

	virtual I_PoolPlayer *CreatePoolPlayer(int iDevice,const Format &iFormat,long iBufSize)
	{return CreateWOPoolPlayer(iDevice,iFormat,iBufSize);}

	virtual I_PoolPlayer *CreatePoolPlayer(int iDevice,I_SeekableInputStream &ioStream)
	{return CreateWOPoolPlayer(iDevice,ioStream);}

	virtual I_PoolPlayer *CreatePoolPlayer(I_PoolPlayer &iDuplicateSrc)
	{return CreateWOPoolPlayer(iDuplicateSrc);}


	virtual void DestroyPlayer(I_StreamPlayer *player);
	virtual void DestroyPlayer(I_PoolPlayer *player);



	virtual int GetDeviceNum(void);
	virtual const PlayDeviceData *GetDeviceData(int index);
	virtual const PlayDeviceDataW *GetDeviceDataW(int index);
	virtual bool TestOpenDevice(int index,const Format &format);

	virtual void UpdateDeviceList(void);
	virtual void UpdateDeviceListW(void);
	virtual void DeleteDeviceList(void);



	virtual I_waveOutStreamPlayer *CreateWOStreamPlayer
		(int iDevice,const Format &iFormat,long iBufsize = 0,int iBufnum = 3);
	virtual I_waveOutStreamPlayer *CreateWOStreamPlayer
		(int iDevice,I_InputStream &setStream,long iBufsize = 0,int iBufnum = 3);

	virtual I_waveOutPoolPlayer *CreateWOPoolPlayer(int iDevice,const Format &iFormat,long iBufSize);
	virtual I_waveOutPoolPlayer *CreateWOPoolPlayer(int iDevice,I_SeekableInputStream &ioStream);
	virtual I_waveOutPoolPlayer *CreateWOPoolPlayer(I_PoolPlayer &iDuplicateSrc);


	virtual const waveOutDeviceData *GetWODeviceData(int index);
	virtual const waveOutDeviceDataW *GetWODeviceDataW(int index);
	virtual const UINT *GetWODeviceID(int index);


	static waveOutPlayDriver &GetInstance(void);
private:
	static waveOutDeviceData *list;
	static waveOutDeviceDataW *wlist;

private:
	waveOutPlayDriver(waveOutPlayDriver &);
	void operator=(const waveOutPlayDriver &);
};


class waveOutExVolumePlayDriver : public waveOutPlayDriver
{
private:
	waveOutExVolumePlayDriver(void) : waveOutPlayDriver() {}
public:
	virtual I_waveOutStreamPlayer *CreateWOStreamPlayer
		(int iDevice,const Format &iFormat,long iBufsize = 0,int iBufnum = 3);
	virtual I_waveOutStreamPlayer *CreateWOStreamPlayer
		(int iDevice,I_InputStream &setStream,long iBufsize = 0,int iBufnum = 3);

	virtual I_waveOutPoolPlayer *CreateWOPoolPlayer(int iDevice,const Format &iFormat,long iBufSize);
	virtual I_waveOutPoolPlayer *CreateWOPoolPlayer(int iDevice,I_SeekableInputStream &ioStream);
	virtual I_waveOutPoolPlayer *CreateWOPoolPlayer(I_PoolPlayer &iDuplicateSrc);


	static waveOutExVolumePlayDriver &GetInstance(void);
};

}//namespace Sound
}//namespace Juna

#endif

